# generated by datamodel-codegen:
#   filename:  qpcr.json
#   timestamp: 2024-01-12T14:18:33+00:00

from __future__ import annotations

from dataclasses import dataclass
from enum import Enum
from typing import Optional

from allotropy.allotrope.models.shared.definitions.custom import (
    TNullableQuantityValueUnitless,
    TQuantityValueDegreeCelsius,
    TQuantityValueMicroliter,
    TQuantityValueNumber,
    TQuantityValuePicogramPerMilliliter,
    TQuantityValueSecondTime,
    TQuantityValueUnitless,
)
from allotropy.allotrope.models.shared.definitions.definitions import (
    TBooleanValue,
    TDatacubeData,
    TDatacubeStructure,
    TDateTimeValue,
    TStringValue,
)


class ExperimentType(Enum):
    genotyping_qPCR_experiment = "genotyping qPCR experiment"
    relative_standard_curve_qPCR_experiment = "relative standard curve qPCR experiment"
    melt_curve_qPCR_experiment = "melt curve qPCR experiment"
    comparative_CT_qPCR_experiment = "comparative CT qPCR experiment"
    standard_curve_qPCR_experiment = "standard curve qPCR experiment"
    qPCR_experiment = "qPCR experiment"
    presence_absence_qPCR_experiment = "presence/absence qPCR experiment"


class ContainerType(Enum):
    reactor = "reactor"
    controlled_lab_reactor = "controlled lab reactor"
    tube = "tube"
    well_plate = "well plate"
    differential_scanning_calorimetry_pan = "differential scanning calorimetry pan"
    qPCR_reaction_block = "qPCR reaction block"
    vial_rack = "vial rack"
    pan = "pan"
    reservoir = "reservoir"
    array_card_block = "array card block"
    capillary = "capillary"
    disintegration_apparatus_basket = "disintegration apparatus basket"
    jar = "jar"
    container = "container"
    tray = "tray"
    basket = "basket"
    cell_holder = "cell holder"


@dataclass
class DataSourceDocumentItem:
    data_source_identifier: Optional[TStringValue] = None
    data_source_feature: Optional[TStringValue] = None


@dataclass
class DataSourceAggregateDocument:
    data_source_document: Optional[list[DataSourceDocumentItem]] = None


@dataclass
class DataProcessingDocument1:
    reference_DNA_description: Optional[TStringValue] = None
    reference_sample_description: Optional[TStringValue] = None


@dataclass
class DeviceSystemDocument:
    device_identifier: TStringValue
    model_number: TStringValue
    device_serial_number: TStringValue
    asset_management_identifier: Optional[TStringValue] = None
    firmware_version: Optional[TStringValue] = None
    description: Optional[TStringValue] = None
    brand_name: Optional[TStringValue] = None
    product_manufacturer: Optional[TStringValue] = None


@dataclass
class DataSystemDocument:
    data_system_instance_identifier: Optional[TStringValue] = None
    file_name: Optional[TStringValue] = None
    UNC_path: Optional[TStringValue] = None
    software_name: Optional[TStringValue] = None
    software_version: Optional[TStringValue] = None
    ASM_converter_name: Optional[TStringValue] = None
    ASM_converter_version: Optional[TStringValue] = None


@dataclass
class SampleDocument:
    sample_identifier: TStringValue
    batch_identifier: Optional[TStringValue] = None
    sample_role_type: Optional[TStringValue] = None
    well_location_identifier: Optional[TStringValue] = None
    well_plate_identifier: Optional[TStringValue] = None
    mass_concentration: Optional[TQuantityValuePicogramPerMilliliter] = None


@dataclass
class DeviceControlDocumentItem:
    device_type: TStringValue
    measurement_method_identifier: TStringValue
    PCR_detection_chemistry: TStringValue
    device_identifier: Optional[TStringValue] = None
    detection_type: Optional[TStringValue] = None
    total_cycle_number_setting: Optional[TQuantityValueNumber] = None
    denaturing_temperature_setting: Optional[TQuantityValueDegreeCelsius] = None
    denaturing_time_setting: Optional[TQuantityValueSecondTime] = None
    annealing_temperature_setting: Optional[TQuantityValueDegreeCelsius] = None
    annealing_time_setting: Optional[TQuantityValueSecondTime] = None
    extension_temperature_setting: Optional[TQuantityValueDegreeCelsius] = None
    extension_time_setting: Optional[TQuantityValueSecondTime] = None
    reporter_dye_setting: Optional[TStringValue] = None
    quencher_dye_setting: Optional[TStringValue] = None
    passive_reference_dye_setting: Optional[TStringValue] = None


@dataclass
class DeviceControlAggregateDocument:
    device_control_document: list[DeviceControlDocumentItem]


@dataclass
class DataProcessingDocument:
    cycle_threshold_value_setting: TQuantityValueUnitless
    automatic_cycle_threshold_enabled_setting: Optional[TBooleanValue] = None
    automatic_baseline_determination_enabled_setting: Optional[TBooleanValue] = None
    baseline_determination_start_cycle_setting: Optional[TQuantityValueNumber] = None
    baseline_determination_end_cycle_setting: Optional[TQuantityValueNumber] = None
    genotyping_determination_method: Optional[TStringValue] = None
    genotyping_determination_method_setting: Optional[TQuantityValueUnitless] = None


@dataclass
class CalculatedDataDocumentItem:
    calculated_data_identifier: Optional[TStringValue] = None
    data_source_aggregate_document: Optional[DataSourceAggregateDocument] = None
    data_processing_document: Optional[DataProcessingDocument1] = None
    calculated_data_name: Optional[TStringValue] = None
    calculated_data_description: Optional[TStringValue] = None
    calculated_datum: Optional[TQuantityValueUnitless] = None


@dataclass
class TCalculatedDataAggregateDocument:
    calculated_data_document: Optional[list[CalculatedDataDocumentItem]] = None


@dataclass
class NormalizedReporterDataCube:
    label: Optional[str] = None
    cube_structure: Optional[TDatacubeStructure] = None
    data: Optional[TDatacubeData] = None


@dataclass
class BaselineCorrectedReporterDataCube:
    label: Optional[str] = None
    cube_structure: Optional[TDatacubeStructure] = None
    data: Optional[TDatacubeData] = None


@dataclass
class ProcessedDataDocumentItem:
    data_processing_document: DataProcessingDocument
    cycle_threshold_result: TNullableQuantityValueUnitless
    normalized_reporter_result: Optional[TQuantityValueUnitless] = None
    normalized_reporter_data_cube: Optional[NormalizedReporterDataCube] = None
    baseline_corrected_reporter_result: Optional[TQuantityValueUnitless] = None
    baseline_corrected_reporter_data_cube: Optional[
        BaselineCorrectedReporterDataCube
    ] = None
    genotyping_determination_result: Optional[TStringValue] = None


@dataclass
class ProcessedDataAggregateDocument:
    processed_data_document: list[ProcessedDataDocumentItem]


@dataclass
class ReporterDyeDataCube:
    label: Optional[str] = None
    cube_structure: Optional[TDatacubeStructure] = None
    data: Optional[TDatacubeData] = None


@dataclass
class PassiveReferenceDyeDataCube:
    label: Optional[str] = None
    cube_structure: Optional[TDatacubeStructure] = None
    data: Optional[TDatacubeData] = None


@dataclass
class MeltingCurveDataCube:
    label: Optional[str] = None
    cube_structure: Optional[TDatacubeStructure] = None
    data: Optional[TDatacubeData] = None


@dataclass
class MeasurementDocumentItem:
    measurement_identifier: TStringValue
    measurement_time: TDateTimeValue
    target_DNA_description: TStringValue
    sample_document: SampleDocument
    device_control_aggregate_document: DeviceControlAggregateDocument
    processed_data_aggregate_document: ProcessedDataAggregateDocument
    reporter_dye_data_cube: Optional[ReporterDyeDataCube] = None
    passive_reference_dye_data_cube: Optional[PassiveReferenceDyeDataCube] = None
    melting_curve_data_cube: Optional[MeltingCurveDataCube] = None


@dataclass
class MeasurementAggregateDocument:
    plate_well_count: TQuantityValueNumber
    measurement_document: list[MeasurementDocumentItem]
    analytical_method_identifier: Optional[TStringValue] = None
    experimental_data_identifier: Optional[TStringValue] = None
    experiment_type: Optional[ExperimentType] = None
    container_type: Optional[ContainerType] = None
    well_volume: Optional[TQuantityValueMicroliter] = None


@dataclass
class QPCRDocumentItem:
    measurement_aggregate_document: MeasurementAggregateDocument
    analyst: Optional[TStringValue] = None
    submitter: Optional[TStringValue] = None
    calculated_data_aggregate_document: Optional[
        TCalculatedDataAggregateDocument
    ] = None


@dataclass
class QPCRAggregateDocument:
    device_system_document: DeviceSystemDocument
    qPCR_document: list[QPCRDocumentItem]
    data_system_document: Optional[DataSystemDocument] = None
    calculated_data_aggregate_document: Optional[
        TCalculatedDataAggregateDocument
    ] = None


@dataclass
class Model:
    qPCR_aggregate_document: Optional[QPCRAggregateDocument] = None
    manifest: str = (
        "http://purl.allotrope.org/manifests/pcr/BENCHLING/2023/09/qpcr.manifest"
    )
